Index: /trunk/src/sys/arch/mips/include/asm.h
===================================================================
--- /trunk/src/sys/arch/mips/include/asm.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/asm.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: asm.h,v 1.40.38.12 2010/02/15 03:12:17 matt Exp $	*/
+/*	$NetBSD: asm.h,v 1.40.38.14 2011/04/29 08:26:19 matt Exp $	*/
 
 /*
@@ -55,5 +55,5 @@
 #define	_MIPS_ASM_H
 
-#include <machine/cdefs.h>	/* for API selection */
+#include <sys/cdefs.h>		/* for API selection */
 #include <mips/regdef.h>
 
@@ -88,9 +88,5 @@
 # define _C_LABEL(x)	x
 #else
-# ifdef __STDC__
-#  define _C_LABEL(x)	_ ## x
-# else
-#  define _C_LABEL(x)	_/**/x
-# endif
+# define _C_LABEL(x)	__CONCAT(_,x)
 #endif
 
@@ -118,11 +114,33 @@
  * WARN_REFERENCES: create a warning if the specified symbol is referenced.
  */
-#ifdef __STDC__
-#define	WARN_REFERENCES(_sym,_msg)				\
-	.section .gnu.warning. ## _sym ; .ascii _msg ; .text
-#else
-#define	WARN_REFERENCES(_sym,_msg)				\
-	.section .gnu.warning./**/_sym ; .ascii _msg ; .text
-#endif /* __STDC__ */
+#define	WARN_REFERENCES(sym,msg)					\
+	.pushsection __CONCAT(.gnu.warning.,sym);			\
+	.ascii msg;							\
+	.popsection
+
+/*
+ * STATIC_LEAF_NOPROFILE
+ *	No profilable local leaf routine.
+ */
+#define	STATIC_LEAF_NOPROFILE(x)	\
+	.ent	_C_LABEL(x), 0;		\
+_C_LABEL(x): ;				\
+	.frame sp, 0, ra
+
+/*
+ * LEAF_NOPROFILE
+ *	No profilable leaf routine.
+ */
+#define	LEAF_NOPROFILE(x)		\
+	.globl	_C_LABEL(x);		\
+	STATIC_LEAF_NOPROFILE(x)
+
+/*
+ * STATIC_LEAF
+ *	Declare a local leaf function.
+ */
+#define	STATIC_LEAF(x)			\
+	STATIC_LEAF_NOPROFILE(x);	\
+	MCOUNT
 
 /*
@@ -134,38 +152,6 @@
  */
 #define	LEAF(x)				\
-	.globl	_C_LABEL(x);		\
-	.ent	_C_LABEL(x), 0;		\
-_C_LABEL(x): ;				\
-	.frame sp, 0, ra;		\
+	LEAF_NOPROFILE(x);		\
 	MCOUNT
-
-/*
- * LEAF_NOPROFILE
- *	No profilable leaf routine.
- */
-#define	LEAF_NOPROFILE(x)		\
-	.globl	_C_LABEL(x);		\
-	.ent	_C_LABEL(x), 0;		\
-_C_LABEL(x): ;				\
-	.frame	sp, 0, ra
-
-/*
- * STATIC_LEAF
- *	Declare a local leaf function.
- */
-#define	STATIC_LEAF(x)			\
-	.ent	_C_LABEL(x), 0;		\
-_C_LABEL(x): ;				\
-	.frame sp, 0, ra;		\
-	MCOUNT
-
-/*
- * XLEAF
- *	declare alternate entry to leaf routine
- */
-#define	XLEAF(x)			\
-	.globl	_C_LABEL(x);		\
-	AENT (_C_LABEL(x));		\
-_C_LABEL(x):
 
 /*
@@ -178,24 +164,44 @@
 
 /*
+ * XLEAF
+ *	declare alternate entry to leaf routine
+ */
+#define	XLEAF(x)			\
+	.globl	_C_LABEL(x);		\
+	STATIC_XLEAF(x)
+
+/*
+ * STATIC_NESTED_NOPROFILE
+ *	No profilable local nested routine.
+ */
+#define	STATIC_NESTED_NOPROFILE(x, fsize, retpc)	\
+	.ent	_C_LABEL(x), 0;			\
+_C_LABEL(x): ;					\
+	.frame	sp, fsize, retpc
+
+/*
+ * NESTED_NOPROFILE
+ *	No profilable nested routine.
+ */
+#define	NESTED_NOPROFILE(x, fsize, retpc)	\
+	.globl	_C_LABEL(x);			\
+	STATIC_NESTED_NOPROFILE(x, fsize, retpc)
+
+/*
  * NESTED
  *	A function calls other functions and needs
  *	therefore stack space to save/restore registers.
  */
-#define	NESTED(x, fsize, retpc)		\
-	.globl	_C_LABEL(x);		\
-	.ent	_C_LABEL(x), 0; 	\
-_C_LABEL(x): ;				\
-	.frame	sp, fsize, retpc;	\
+#define	NESTED(x, fsize, retpc)			\
+	NESTED_NOPROFILE(x, fsize, retpc);	\
 	MCOUNT
 
 /*
- * NESTED_NOPROFILE(x)
- *	No profilable nested routine.
- */
-#define	NESTED_NOPROFILE(x, fsize, retpc)	\
-	.globl	_C_LABEL(x);		\
-	.ent	_C_LABEL(x), 0;		\
-_C_LABEL(x): ;				\
-	.frame	sp, fsize, retpc
+ * STATIC_NESTED
+ *	No profilable local nested routine.
+ */
+#define	STATIC_NESTED(x, fsize, retpc)			\
+	STATIC_NESTED_NOPROFILE(x, fsize, retpc);	\
+	MCOUNT
 
 /*
@@ -212,5 +218,5 @@
  *	Mark end of a procedure.
  */
-#define	END(x) \
+#define	END(x)				\
 	.end _C_LABEL(x);		\
 	.size _C_LABEL(x), . - _C_LABEL(x)
@@ -238,15 +244,8 @@
 	EXPORT(x);			\
 
-#ifdef __STDC__
 #define	VECTOR_END(x)			\
-	EXPORT(x ## _end);		\
+	EXPORT(__CONCAT(x,_end));	\
 	END(x);				\
 	.org _C_LABEL(x) + 0x80
-#else
-#define	VECTOR_END(x)			\
-	EXPORT(x/**/_end);		\
-	END(x);				\
-	.org _C_LABEL(x) + 0x80
-#endif
 
 /*
@@ -618,5 +617,6 @@
 
 /* See lock_stubs.S. */
-#define	MIPS_LOCK_RAS_SIZE	128
+#define	LOG2_MIPS_LOCK_RAS_SIZE	8
+#define	MIPS_LOCK_RAS_SIZE	256	/* 16 bytes left over */
 
 #define	CPUVAR(off) _C_LABEL(cpu_info_store)+__CONCAT(CPU_INFO_,off)
Index: /trunk/src/sys/arch/mips/include/cache.h
===================================================================
--- /trunk/src/sys/arch/mips/include/cache.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/cache.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cache.h,v 1.9.96.2 2010/01/26 21:19:25 matt Exp $	*/
+/*	cache.h,v 1.9.96.3 2011/04/29 08:26:19 matt Exp	*/
 
 /*
@@ -208,5 +208,5 @@
 
 	u_int mci_cache_prefer_mask;
-#if defined(MIPS2) || defined(MIPS3) || defined(MIPS3_5900)
+#if (MIPS2 + MIPS3 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL | MIPS64R2_RMIXL) > 0
 	u_int mci_cache_alias_mask;
 
@@ -215,5 +215,5 @@
 #define	MIPS_CACHE_ALIAS_MASK		mips_cache_info.mci_cache_alias_mask
 #define	MIPS_CACHE_VIRTUAL_ALIAS	mips_cache_info.mci_cache_virtual_alias
-#elif defined(MIPS1) || defined(MIPS32) || defined(MIPS64)
+#elif defined(MIPS1)
 #define	MIPS_CACHE_ALIAS_MASK		0
 #define	MIPS_CACHE_VIRTUAL_ALIAS	false
Index: /trunk/src/sys/arch/mips/include/cpu.h
===================================================================
--- /trunk/src/sys/arch/mips/include/cpu.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/cpu.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cpu.h,v 1.90.16.28 2010/03/21 18:17:21 cliff Exp $	*/
+/*	cpu.h,v 1.90.16.36 2011/04/29 08:26:20 matt Exp	*/
 
 /*-
@@ -46,4 +46,10 @@
 #ifdef _KERNEL
 
+#if defined(_KERNEL_OPT)
+#include "opt_cputype.h"
+#include "opt_lockdebug.h"
+#include "opt_multiprocessor.h"
+#endif
+
 #ifndef _LOCORE
 #include <sys/cpu_data.h>
@@ -51,9 +57,27 @@
 #include <sys/evcnt.h>
 
-#if defined(_KERNEL_OPT)
-#include "opt_cputype.h"
-#include "opt_lockdebug.h"
-#include "opt_multiprocessor.h"
-#endif
+typedef struct cpu_watchpoint {
+	register_t	cw_addr;
+	register_t	cw_mask;
+	uint32_t	cw_asid;
+	uint32_t	cw_mode;
+} cpu_watchpoint_t;
+/* (abstract) mode bits */
+#define CPUWATCH_WRITE	__BIT(0)
+#define CPUWATCH_READ	__BIT(1)
+#define CPUWATCH_EXEC	__BIT(2)
+#define CPUWATCH_MASK	__BIT(3)
+#define CPUWATCH_ASID	__BIT(4)
+#define CPUWATCH_RWX	(CPUWATCH_EXEC|CPUWATCH_READ|CPUWATCH_WRITE)
+
+#define CPUWATCH_MAX	8	/* max possible number of watchpoints */
+
+u_int		  cpuwatch_discover(void);
+void		  cpuwatch_free(cpu_watchpoint_t *);
+cpu_watchpoint_t *cpuwatch_alloc(void);
+void		  cpuwatch_set_all(void);
+void		  cpuwatch_clr_all(void);
+void		  cpuwatch_set(cpu_watchpoint_t *);
+void		  cpuwatch_clr(cpu_watchpoint_t *);
 
 struct cpu_info {
@@ -78,8 +102,11 @@
 	int ci_cpl;			/* current [interrupt] priority level */
 	uint32_t ci_next_cp0_clk_intr;	/* for hard clock intr scheduling */
-	struct evcnt ci_count_compare_evcnt;		/* hard clock intr counter */
-	struct evcnt ci_count_compare_missed_evcnt;	/* hard clock miss counter */
+	struct evcnt ci_ev_count_compare;		/* hard clock intr counter */
+	struct evcnt ci_ev_count_compare_missed;	/* hard clock miss counter */
 	struct lwp *ci_softlwps[SOFTINT_COUNT];
-#define	ci_softints	ci_data.cpu_softints
+	volatile u_int ci_softints;
+	struct evcnt ci_ev_fpu_loads;	/* fpu load counter */
+	struct evcnt ci_ev_fpu_saves;	/* fpu save counter */
+	struct evcnt ci_ev_tlbmisses;
 
 	/*
@@ -87,9 +114,16 @@
 	 */
 	int ci_tlb_slot;		/* reserved tlb entry for cpu_info */
+	u_int ci_pmap_asid_cur;		/* current ASID */
 	struct pmap_tlb_info *ci_tlb_info; /* tlb information for this cpu */
-	struct segtab *ci_pmap_segbase;
+	union segtab *ci_pmap_seg0tab;
+#ifdef _LP64
+	union segtab *ci_pmap_segtab;
+#else
 	vaddr_t ci_pmap_srcbase;	/* starting VA of ephemeral src space */
 	vaddr_t ci_pmap_dstbase;	/* starting VA of ephemeral dst space */
-
+#endif
+
+	u_int ci_cpuwatch_count;	/* number of watchpoints on this CPU */
+	cpu_watchpoint_t ci_cpuwatch_tab[CPUWATCH_MAX];
 
 #ifdef MULTIPROCESSOR
@@ -144,19 +178,27 @@
 
 #ifdef _KERNEL
-#if defined(_LKM) || defined(_STANDALONE)
+#if defined(_MODULAR) || defined(_LKM) || defined(_STANDALONE)
 /* Assume all CPU architectures are valid for LKM's and standlone progs */
-#define	MIPS1	1
-#define	MIPS3	1
-#define	MIPS4	1
-#define	MIPS32	1
-#define	MIPS64	1
-#endif
-
-#if (MIPS1 + MIPS3 + MIPS4 + MIPS32 + MIPS64) == 0
-#error at least one of MIPS1, MIPS3, MIPS4, MIPS32 or MIPS64 must be specified
+#define	MIPS1		1
+#define	MIPS3		1
+#define	MIPS4		1
+#define	MIPS32		1
+#define	MIPS32R2	1
+#define	MIPS64		1
+#define	MIPS64R2	1
+#define	MIPS64_RMIXL	1
+#define	MIPS64R2_RMIXL	1
+#endif
+
+#if (MIPS1 + MIPS3 + MIPS4 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) == 0
+#error at least one of MIPS1, MIPS3, MIPS4, MIPS32, MIPS32R2, MIPS64, MIPS64R2, MIPS64_RMIXL, or MIPS64R2_RMIXL must be specified
 #endif
 
 /* Shortcut for MIPS3 or above defined */
-#if defined(MIPS3) || defined(MIPS4) || defined(MIPS32) || defined(MIPS64)
+#if defined(MIPS3) || defined(MIPS4) \
+    || defined(MIPS32) || defined(MIPS32R2) \
+    || defined(MIPS64) || defined(MIPS64R2) \
+    || defined(MIPS64_RMIXL) || defined(MIPS64R2_RMIXL)
+
 #define	MIPS3_PLUS	1
 #define __HAVE_CPU_COUNTER
@@ -170,12 +212,14 @@
  */
 
-#define	CPU_ARCH_MIPSx	0		/* XXX unknown */
-#define	CPU_ARCH_MIPS1	(1 << 0)
-#define	CPU_ARCH_MIPS2	(1 << 1)
-#define	CPU_ARCH_MIPS3	(1 << 2)
-#define	CPU_ARCH_MIPS4	(1 << 3)
-#define	CPU_ARCH_MIPS5	(1 << 4)
-#define	CPU_ARCH_MIPS32	(1 << 5)
-#define	CPU_ARCH_MIPS64	(1 << 6)
+#define	CPU_ARCH_MIPSx		0		/* XXX unknown */
+#define	CPU_ARCH_MIPS1		(1 << 0)
+#define	CPU_ARCH_MIPS2		(1 << 1)
+#define	CPU_ARCH_MIPS3		(1 << 2)
+#define	CPU_ARCH_MIPS4		(1 << 3)
+#define	CPU_ARCH_MIPS5		(1 << 4)
+#define	CPU_ARCH_MIPS32		(1 << 5)
+#define	CPU_ARCH_MIPS64		(1 << 6)
+#define	CPU_ARCH_MIPS32R2	(1 << 7)
+#define	CPU_ARCH_MIPS64R2	(1 << 8)
 
 /* Note: must be kept in sync with -ffixed-?? Makefile.mips. */
@@ -193,12 +237,12 @@
 #define	curlwp			mips_curlwp
 #define	curcpu()		(curlwp->l_cpu)
-#define	curpcb			(&curlwp->l_addr->u_pcb)
+#define	curpcb			((struct pcb *)lwp_getpcb(curlwp))
 #ifdef MULTIPROCESSOR
-#define	cpu_number()		(curcpu()->ci_cpuid)
-#define	CPU_IS_PRIMARY(ci)	((ci)->ci_cpuid == 0)
+#define	cpu_number()		(curcpu()->ci_index)
+#define	CPU_IS_PRIMARY(ci)	((ci)->ci_flags & CPUF_PRIMARY)
 #else
-#define	cpu_number()		(0L)
-#endif
-#define	cpu_proc_fork(p1, p2)	((void)((p2)->p_md.md_abi = (p1)->p_md.md_abi))
+#define	cpu_number()		(0)
+#define	CPU_IS_PRIMARY(ci)	(true)
+#endif
 
 /* XXX simonb
@@ -251,5 +295,5 @@
 #endif	/* !_LOCORE */
 
-#if ((MIPS1 + MIPS3 + MIPS4 + MIPS32 + MIPS64) == 1) || defined(_LOCORE)
+#if ((MIPS1 + MIPS3 + MIPS4 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) == 1) || defined(_LOCORE)
 
 #if defined(MIPS1)
@@ -258,5 +302,7 @@
 # define CPUIS64BITS		0
 # define CPUISMIPS32		0
+# define CPUISMIPS32R2		0
 # define CPUISMIPS64		0
+# define CPUISMIPS64R2		0
 # define CPUISMIPSNN		0
 # define MIPS_HAS_R4K_MMU	0
@@ -270,10 +316,12 @@
 # define CPUIS64BITS		1
 # define CPUISMIPS32		0
+# define CPUISMIPS32R2		0
 # define CPUISMIPS64		0
+# define CPUISMIPS64R2		0
 # define CPUISMIPSNN		0
 # define MIPS_HAS_R4K_MMU	1
 # define MIPS_HAS_CLOCK		1
 # if defined(_LOCORE)
-#  if !defined(MIPS3_5900) && !defined(MIPS3_4100)
+#  if !defined(MIPS3_4100)
 #   define MIPS_HAS_LLSC	1
 #  else
@@ -290,5 +338,7 @@
 # define CPUIS64BITS		0
 # define CPUISMIPS32		1
+# define CPUISMIPS32R2		0
 # define CPUISMIPS64		0
+# define CPUISMIPS64R2		0
 # define CPUISMIPSNN		1
 # define MIPS_HAS_R4K_MMU	1
@@ -297,10 +347,12 @@
 # define MIPS_HAS_LLADDR	((mips_options.mips_cpu_flags & CPU_MIPS_NO_LLADDR) == 0)
 
-#elif defined(MIPS64)
+#elif defined(MIPS32R2)
 
 # define CPUISMIPS3		1
-# define CPUIS64BITS		1
+# define CPUIS64BITS		0
 # define CPUISMIPS32		0
-# define CPUISMIPS64		1
+# define CPUISMIPS32R2		1
+# define CPUISMIPS64		0
+# define CPUISMIPS64R2		0
 # define CPUISMIPSNN		1
 # define MIPS_HAS_R4K_MMU	1
@@ -309,4 +361,32 @@
 # define MIPS_HAS_LLADDR	((mips_options.mips_cpu_flags & CPU_MIPS_NO_LLADDR) == 0)
 
+#elif defined(MIPS64) || defined(MIPS64_RMIXL)
+
+# define CPUISMIPS3		1
+# define CPUIS64BITS		1
+# define CPUISMIPS32		0
+# define CPUISMIPS32R2		0
+# define CPUISMIPS64		1
+# define CPUISMIPS64R2		0
+# define CPUISMIPSNN		1
+# define MIPS_HAS_R4K_MMU	1
+# define MIPS_HAS_CLOCK		1
+# define MIPS_HAS_LLSC		1
+# define MIPS_HAS_LLADDR	((mips_options.mips_cpu_flags & CPU_MIPS_NO_LLADDR) == 0)
+
+#elif defined(MIPS64R2) || defined(MIPS64R2_RMIXL)
+
+# define CPUISMIPS3		1
+# define CPUIS64BITS		1
+# define CPUISMIPS32		0
+# define CPUISMIPS32R2		0
+# define CPUISMIPS64		0
+# define CPUISMIPS64R2		1
+# define CPUISMIPSNN		1
+# define MIPS_HAS_R4K_MMU	1
+# define MIPS_HAS_CLOCK		1
+# define MIPS_HAS_LLSC		1
+# define MIPS_HAS_LLADDR	((mips_options.mips_cpu_flags & CPU_MIPS_NO_LLADDR) == 0)
+
 #endif
 
@@ -327,8 +407,10 @@
 #define	CPUISMIPS5	((mips_options.mips_cpu_arch & CPU_ARCH_MIPS5) != 0)
 #define	CPUISMIPS32	((mips_options.mips_cpu_arch & CPU_ARCH_MIPS32) != 0)
+#define	CPUISMIPS32R2	((mips_options.mips_cpu_arch & CPU_ARCH_MIPS32R2) != 0)
 #define	CPUISMIPS64	((mips_options.mips_cpu_arch & CPU_ARCH_MIPS64) != 0)
-#define	CPUISMIPSNN	((mips_options.mips_cpu_arch & (CPU_ARCH_MIPS32 | CPU_ARCH_MIPS64)) != 0)
+#define	CPUISMIPS64R2	((mips_options.mips_cpu_arch & CPU_ARCH_MIPS64R2) != 0)
+#define	CPUISMIPSNN	((mips_options.mips_cpu_arch & (CPU_ARCH_MIPS32 | CPU_ARCH_MIPS32R2 | CPU_ARCH_MIPS64 | CPU_ARCH_MIPS64R2)) != 0)
 #define	CPUIS64BITS	((mips_options.mips_cpu_arch & \
-	(CPU_ARCH_MIPS3 | CPU_ARCH_MIPS4 | CPU_ARCH_MIPS64)) != 0)
+	(CPU_ARCH_MIPS3 | CPU_ARCH_MIPS4 | CPU_ARCH_MIPS64 | CPU_ARCH_MIPS64R2)) != 0)
 
 #define	MIPS_HAS_CLOCK	(mips_options.mips_cpu_arch >= CPU_ARCH_MIPS3)
@@ -349,4 +431,14 @@
  */
 #define	cpu_swapout(p)			panic("cpu_swapout: can't get here");
+
+/*
+ * Send an inter-processor interupt to each other CPU (excludes curcpu())
+ */
+void cpu_broadcast_ipi(int);
+
+/*
+ * Send an inter-processor interupt to CPUs in cpuset (excludes curcpu())
+ */
+void cpu_multicast_ipi(__cpuset_t, int);
 
 /*
@@ -401,6 +493,10 @@
  * Misc prototypes and variable declarations.
  */
+#define	LWP_PC(l)	cpu_lwp_pc(l)
+
+struct proc;
 struct lwp;
-struct user;
+struct pcb;
+struct reg;
 
 /*
@@ -425,19 +521,31 @@
 extern int mips_poolpage_vmfreelist;	/* freelist to allocate poolpages */
 
-/* cpu_subr.c */
-#ifdef MULTIPROCESSOR
-extern volatile u_long cpus_running;
-extern volatile u_long cpus_hatched;
-extern volatile u_long cpus_halted;
-#endif
-
 struct cpu_info *
-	cpu_info_alloc(struct pmap_tlb_info *, u_int);
+	cpu_info_alloc(struct pmap_tlb_info *, cpuid_t, cpuid_t, cpuid_t,
+	    cpuid_t);
 void	cpu_attach_common(device_t, struct cpu_info *);
 void	cpu_startup_common(void);
+#ifdef _LP64
+void	cpu_vmspace_exec(struct lwp *, vaddr_t, vaddr_t);
+#endif
+
 #ifdef MULTIPROCESSOR
 void	cpu_hatch(struct cpu_info *ci);
 void	cpu_trampoline(void);
 void	cpu_boot_secondary_processors(void);
+void	cpu_halt(void);
+void	cpu_halt_others(void);
+void	cpu_pause(struct reg *);
+void	cpu_pause_others(void);
+void	cpu_resume(int);
+void	cpu_resume_others(void);
+int	cpu_is_paused(int);
+void	cpu_debug_dump(void);
+
+extern volatile __cpuset_t cpus_running;
+extern volatile __cpuset_t cpus_hatched;
+extern volatile __cpuset_t cpus_paused;
+extern volatile __cpuset_t cpus_resumed;
+extern volatile __cpuset_t cpus_halted;
 #endif
 
@@ -525,19 +633,13 @@
 /* mips_fpu.c */
 void	fpu_init(void);
-void	fpudiscard_lwp(struct lwp *);
-void	fpuload_lwp(struct lwp *);
-void	fpusave_lwp(struct lwp *);
+void	fpu_discard(void);
+void	fpu_load(void);
+void	fpu_save(void);
+void	fpu_save_lwp(struct lwp *);
 void	fpusave_cpu(struct cpu_info *);
 
 /* mips_machdep.c */
-struct mips_vmfreelist;
-struct phys_ram_seg;
 void	dumpsys(void);
-int	savectx(struct user *);
-void	mips_init_msgbuf(void);
-void	mips_init_lwp0_uarea(void);
-void	mips_page_physload(vaddr_t, vaddr_t,
-	    const struct phys_ram_seg *, size_t,
-	    const struct mips_vmfreelist *, size_t);
+int	savectx(struct pcb *);
 void	cpu_identify(device_t);
 
@@ -547,4 +649,6 @@
 
 /* vm_machdep.c */
+void	cpu_proc_fork(struct proc *, struct proc *);
+vaddr_t	cpu_lwp_pc(struct lwp *);
 void	cpu_uarea_remap(struct lwp *);
 
Index: /trunk/src/sys/arch/mips/include/cpuregs.h
===================================================================
--- /trunk/src/sys/arch/mips/include/cpuregs.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/cpuregs.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cpuregs.h,v 1.74.28.18 2010/04/27 05:44:30 cliff Exp $	*/
+/*	cpuregs.h,v 1.74.28.20 2011/04/29 08:26:20 matt Exp	*/
 
 /*
@@ -133,5 +133,22 @@
 
 /* CPU dependent mtc0 hazard hook */
-#define	COP0_SYNC		/* nothing */
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+# if (MIPS1 + MIPS3 + MIPS32 + MIPS64 + MIPS64_RMIXL) == 0
+#  define COP0_SYNC		sll $0,$0,3	/* EHB */
+#  define JR_HB_RA		.set push; .set mips32r2; jr.hb ra; nop; .set pop
+# else
+#  define COP0_SYNC		sll $0,$0,1; sll $0,$0,1; sll $0,$0,3
+#  define JR_HB_RA		sll $0,$0,1; sll $0,$0,1; jr ra; sll $0,$0,3
+# endif
+#elif (MIPS32 + MIPS64 + MIPS64_RMIXL) > 0
+# define COP0_SYNC		sll $0,$0,1; sll $0,$0,1; sll $0,$0,1
+# define JR_HB_RA		sll $0,$0,1; sll $0,$0,1; jr ra; sll $0,$0,1
+#elif MIPS3 > 0
+# define COP0_SYNC		nop; nop; nop
+# define JR_HB_RA		nop; nop; jr ra; nop
+#else
+# define COP0_SYNC		nop
+# define JR_HB_RA		jr ra; nop
+#endif
 #define	COP0_HAZARD_FPUENABLE	nop; nop; nop; nop;
 
@@ -148,5 +165,5 @@
  *
  * Differences:
- *  r3k has 4 bits of execption type, r4k has 5 bits.
+ *  r3k has 4 bits of exception type, r4k has 5 bits.
  */
 #define	MIPS_CR_BR_DELAY	0x80000000
@@ -250,5 +267,4 @@
 #define	MIPS3_SR_DIAG_CE	0x00020000
 #define	MIPS3_SR_DIAG_PE	0x00010000
-#define	MIPS3_SR_EIE		0x00010000		/* TX79/R5900 */
 #define	MIPS3_SR_KX		0x00000080
 #define	MIPS3_SR_SX		0x00000040
@@ -260,9 +276,4 @@
 #define	MIPS3_SR_ERL		0x00000004
 #define	MIPS3_SR_EXL		0x00000002
-
-#ifdef MIPS3_5900
-#undef MIPS_SR_INT_IE
-#define	MIPS_SR_INT_IE		0x00010001		/* XXX */
-#endif
 
 #define	MIPS_SR_SOFT_RESET	MIPS3_SR_SOFT_RESET
@@ -448,10 +459,4 @@
 
 /*
- * TX79 (R5900) exception vectors
- */
-#define MIPS_R5900_COUNTER_EXC_VEC	MIPS_PHYS_TO_KSEG0(0x0080)
-#define MIPS_R5900_DEBUG_EXC_VEC	MIPS_PHYS_TO_KSEG0(0x0100)
-
-/*
  * MIPS32/MIPS64 (and some MIPS3) dedicated interrupt vector.
  */
@@ -470,6 +475,8 @@
  *  3	MIPS_COP_0_TLB_LO1	.636 r4k TLB entry low, extended.
  *  4	MIPS_COP_0_TLB_CONTEXT	3636 TLB Context.
+ *  4/2	MIPS_COP_0_USERLOCAL	..36 UserLocal.
  *  5	MIPS_COP_0_TLB_PG_MASK	.333 TLB Page Mask register.
  *  6	MIPS_COP_0_TLB_WIRED	.333 Wired TLB number.
+ *  7	MIPS_COP_0_HWRENA	..33 rdHWR Enable.
  *  8	MIPS_COP_0_BAD_VADDR	3636 Bad virtual address.
  *  9	MIPS_COP_0_COUNT	.333 Count register.
@@ -477,12 +484,17 @@
  * 11	MIPS_COP_0_COMPARE	.333 Compare (against Count).
  * 12	MIPS_COP_0_STATUS	3333 Status register.
+ * 12/1	MIPS_COP_0_INTCTL	..33 Interrupt Control.
+ * 12/2	MIPS_COP_0_SRSCTL	..33 Shadow Register Set Selectors.
+ * 12/3	MIPS_COP_0_SRSMAP	..33 Shadow Set Map.
  * 13	MIPS_COP_0_CAUSE	3333 Exception cause register.
  * 14	MIPS_COP_0_EXC_PC	3636 Exception PC.
  * 15	MIPS_COP_0_PRID		3333 Processor revision identifier.
- * 15/1	MIPS_COP_0_EBASE	..33 Exception Base
+ * 15/1	MIPS_COP_0_EBASE	..33 Exception Base.
  * 16	MIPS_COP_0_CONFIG	3333 Configuration register.
  * 16/1	MIPS_COP_0_CONFIG1	..33 Configuration register 1.
  * 16/2	MIPS_COP_0_CONFIG2	..33 Configuration register 2.
  * 16/3	MIPS_COP_0_CONFIG3	..33 Configuration register 3.
+ * 16/6	MIPS_COP_0_CONFIG6	..33 Configuration register 6.
+ * 16/7	MIPS_COP_0_CONFIG7	..33 Configuration register 7.
  * 17	MIPS_COP_0_LLADDR	.336 Load Linked Address.
  * 18	MIPS_COP_0_WATCH_LO	.336 WatchLo register.
@@ -552,4 +564,5 @@
 #define MIPS_COP_0_TCCONTEXT	_(2)  /* 2, 5 */
 #define	MIPS_COP_0_EBASE	_(15) /* 15, 1 */
+#define	MIPS_COP_0_HWRENA	_(7)
 #define	MIPS_COP_0_OSSCRATCH	_(22)
 #define	MIPS_COP_0_DEBUG	_(23)
@@ -714,13 +727,13 @@
 /* XXX simonb: this is before MIPS3_PLUS is defined (and is ugly!) */
 
-#if !(defined(MIPS3) || defined(MIPS4) || defined(MIPS32) || defined(MIPS64)) \
-    && defined(MIPS1)				/* XXX simonb must be neater! */
+#if (MIPS3 + MIPS4 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) == 0 && MIPS1 != 0
 #define	MIPS_TLB_PID_SHIFT		MIPS1_TLB_PID_SHIFT
+#define	MIPS_TLB_PID			MIPS1_TLB_PID
 #define	MIPS_TLB_NUM_PIDS		MIPS1_TLB_NUM_PIDS
 #endif
 
-#if (defined(MIPS3) || defined(MIPS4) || defined(MIPS32) || defined(MIPS64)) \
-    && !defined(MIPS1)				/* XXX simonb must be neater! */
+#if (MIPS3 + MIPS4 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) != 0 && MIPS1 == 0
 #define	MIPS_TLB_PID_SHIFT		0
+#define	MIPS_TLB_PID			MIPS3_TLB_PID
 #define	MIPS_TLB_NUM_PIDS		MIPS3_TLB_NUM_ASIDS
 #endif
@@ -731,7 +744,21 @@
     ((MIPS_HAS_R4K_MMU) ? 0 : MIPS1_TLB_PID_SHIFT)
 
+#define	MIPS_TLB_PID \
+    ((MIPS_HAS_R4K_MMU) ? MIPS3_TLB_PID : MIPS1_TLB_PID)
+
 #define	MIPS_TLB_NUM_PIDS \
     ((MIPS_HAS_R4K_MMU) ? MIPS3_TLB_NUM_ASIDS : MIPS1_TLB_NUM_PIDS)
 #endif
+
+/*
+ * Bits defined for for the HWREna (CP0 register 7, select 0).
+ */
+#define	MIPS_HWRENA_IMPL31		__BIT(31)
+#define	MIPS_HWRENA_IMPL30		__BIT(30)
+#define	MIPS_HWRENA_UL			__BIT(29)	/* Userlocal */
+#define	MIPS_HWRENA_CCRES		__BIT(3)
+#define	MIPS_HWRENA_CC			__BIT(2)
+#define	MIPS_HWRENA_SYNCI_STEP		__BIT(1)
+#define	MIPS_HWRENA_CPUNUM		__BIT(0)
 
 /*
@@ -850,4 +877,5 @@
 #define	MIPS_24KE	0x96	/* MIPS 24KEc			ISA 32  Rel 2 */
 #define	MIPS_74K	0x97	/* MIPS 74Kc/74Kf		ISA 32  Rel 2 */
+#define	MIPS_1004K	0x99	/* MIPS 1004Kc/1004Kf		ISA 32  Rel 2 */
 
 /*
@@ -923,11 +951,8 @@
 #include <mips/r3900regs.h>
 #endif
-#ifdef MIPS3_5900
-#include <mips/r5900regs.h>
-#endif
 #ifdef MIPS64_SB1
 #include <mips/sb1regs.h>
 #endif
-#if defined(MIPS64_XLP) || defined(MIPS64_XLR) || defined(MIPS64_XLS)
+#if (MIPS64_XLR + MIPS64_XLS + MIPS64_XLP) > 0
 #include <mips/rmi/rmixlreg.h>
 #endif
Index: /trunk/src/sys/arch/mips/include/cpuset.h
===================================================================
--- /trunk/src/sys/arch/mips/include/cpuset.h	(revision 152)
+++ /trunk/src/sys/arch/mips/include/cpuset.h	(revision 152)
@@ -0,0 +1,51 @@
+/*	$NetBSD: cpuset.h,v 1.1.2.2 2011/04/29 08:26:20 matt Exp $	*/
+/*	$NetBSD: cpuset.h,v 1.1.2.2 2011/04/29 08:26:20 matt Exp $ */
+
+/*-
+ * Copyright (c) 2004 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _MIPS_CPUSET_H_
+#define	_MIPS_CPUSET_H_
+
+#include <sys/atomic.h>
+
+#define	CPUSET_SINGLE(cpu)		((__cpuset_t)1 << (cpu))
+
+#define	CPUSET_ADD(set, cpu)		atomic_or_64((volatile uint64_t *)&(set), CPUSET_SINGLE(cpu))
+#define	CPUSET_DEL(set, cpu)		atomic_and_64((volatile uint64_t *)&(set), ~CPUSET_SINGLE(cpu))
+#define	CPUSET_SUB(set1, set2)		atomic_and_64((volatile uint64_t *)&(set1), ~(set2))
+
+#define	CPUSET_EXCEPT(set, cpu)		((set) & ~CPUSET_SINGLE(cpu))
+
+#define	CPUSET_HAS_P(set, cpu)		(((set) & CPUSET_SINGLE(cpu)) != 0)
+#define	CPUSET_NEXT(set)		(ffs(set) - 1)
+
+#define	CPUSET_EMPTY_P(set)		((set) == (__cpuset_t)0)
+#define	CPUSET_EQUAL_P(set1, set2)	((set1) == (set2))
+#define	CPUSET_CLEAR(set)		((set) = (__cpuset_t)0)
+#define	CPUSET_ASSIGN(set1, set2)	((set1) = (set2))
+
+#endif /* _MIPS_CPUSET_H_ */
Index: /trunk/src/sys/arch/mips/include/db_machdep.h
===================================================================
--- /trunk/src/sys/arch/mips/include/db_machdep.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/db_machdep.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: db_machdep.h,v 1.22.62.1 2010/02/01 04:16:19 matt Exp $ */
+/* $NetBSD: db_machdep.h,v 1.22.62.4 2011/04/29 08:26:21 matt Exp $ */
 
 /*
@@ -39,5 +39,5 @@
 #include <mips/reg.h>			/* register state */
 #include <mips/regnum.h>		/* symbolic register indices */
-#include <mips/proc.h>			/* register state */
+#include <mips/pcb.h>			/* register state */
 
 
@@ -114,4 +114,8 @@
 db_addr_t next_instr_address(db_addr_t pc, bool bd);
 
+bool ddb_running_on_this_cpu_p(void);
+bool ddb_running_on_any_cpu_p(void);
+void db_resume_others(void);
+
 /*
  * We have machine-dependent commands.
Index: /trunk/src/sys/arch/mips/include/elf_machdep.h
===================================================================
--- /trunk/src/sys/arch/mips/include/elf_machdep.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/elf_machdep.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: elf_machdep.h,v 1.10.96.8 2010/01/26 21:09:54 matt Exp $	*/
+/*	$NetBSD: elf_machdep.h,v 1.10.96.9 2011/04/29 08:26:21 matt Exp $	*/
 
 #ifndef _MIPS_ELF_MACHDEP_H_
@@ -144,5 +144,5 @@
 #define	EF_MIPS_ARCH_64		0x60000000	/* -mips64 code */
 #define	EF_MIPS_ARCH_32R2	0x70000000	/* -mips32r2 code */
-#define	EF_MIPS_ARCH_64R4	0x80000000	/* -mips64r2 code */
+#define	EF_MIPS_ARCH_64R2	0x80000000	/* -mips64r2 code */
 
 #define	EF_MIPS_ABI		0x0000f000
Index: /trunk/src/sys/arch/mips/include/float.h
===================================================================
--- /trunk/src/sys/arch/mips/include/float.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/float.h	(revision 152)
@@ -1,3 +1,35 @@
-/*	$NetBSD: float.h,v 1.13 2003/05/12 15:22:54 kleink Exp $	*/
+/*	$NetBSD: float.h,v 1.13.126.1 2011/04/29 07:48:36 matt Exp $ */
+
+#ifndef _MIPS_FLOAT_H_
+#define _MIPS_FLOAT_H_
+
+#if defined(__mips_n32) || defined(__mips_n64)
+
+#define LDBL_MANT_DIG	113
+#define	LDBL_EPSILON	1.925929944387235853055977942584927319E-34L
+#define	LDBL_DIG	33
+#define	LDBL_MIN_EXP	(-16381)
+#define	LDBL_MIN	3.3621031431120935062626778173217526026E-4932L
+#define	LDBL_MIN_10_EXP	(-4931)
+#define	LDBL_MAX_EXP	16384
+#define	LDBL_MAX	1.1897314953572317650857593266280070162E4932L
+#define	LDBL_MAX_10_EXP	4932
+
+#endif	/* __mips_n32 || __mips_n64 */
 
 #include <sys/float_ieee754.h>
+
+#if defined(__mips_n32) || defined(__mips_n64)
+
+#if !defined(_ANSI_SOURCE) && !defined(_POSIX_C_SOURCE) && \
+    !defined(_XOPEN_SOURCE) || \
+    ((__STDC_VERSION__ - 0) >= 199901L) || \
+    ((_POSIX_C_SOURCE - 0) >= 200112L) || \
+    ((_XOPEN_SOURCE  - 0) >= 600) || \
+    defined(_ISOC99_SOURCE) || defined(_NETBSD_SOURCE)
+#define	DECIMAL_DIG	36
+#endif /* !defined(_ANSI_SOURCE) && ... */
+
+#endif	/* __mips_n32 || __mips_n64 */
+
+#endif	/* _MIPS_FLOAT_H_ */
